



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CODEFORCES 125E MST Company 巧用Kruskal算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CODEFORCES 125E MST Company 巧用Kruskal算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 06:57:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：给定一个带权边无向图，求最小生成树，且满足第一个节点的度为固定的k 无解则输出-1</p>
<p>数据规模： 节点数n和限制k&lt;=5000 边数m&lt;=10^5 时限8sec</p>
<p>思路：</p>
<p>首先时限比较宽，第一个想到的暴力做法是枚举第一个节点（即首都）选中的K条边，复杂度为阶乘级别 无法接受。<strong>但是我们可以确定，问题的关键在于在所有国道中选择哪k条国道</strong>。一旦k条国道选定，最小生成树就是固定的。</p>
<p>考虑一个极端的情况，如果我们直接对这个图运行Kruskal算法，得到了一个树 且 第一个节点的度为k，则这就是正确的答案。当然，一般数据是无法做到的。</p>
<p>那么我们就可以使用一个技巧，如果运行Kruskal算法后第一个节点的度小于k，那么我们在算法运行的序列中将所有国道的位置整体向前移动，使得下一次运行Kruskal算法可以选定更多的国道，我们就离正确答案更近了。反之亦然。</p>
<p><strong> 那么怎样调整所有&ldquo;国道&rdquo;在Kruskal序列中的位置呢？</strong></p>
<p>选定一个double值mid 它可以很大，也可以很小，在排序时&ldquo;国道&rdquo;的权值加上这个mid再与非国道比较，就可以适当的调节所有&ldquo;国道&rdquo;在序列中的位置。</p>
<p>代码如下，只要理解了排序比较函数cmp 也就理解了这个Kruskal的变种算法了。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;cstdlib&gt;<br />
 #include&lt;cmath&gt;<br />
 #include&lt;queue&gt;<br />
 #include&lt;stack&gt;<br />
 #include&lt;map&gt;<br />
 #include&lt;algorithm&gt;<br />
 using namespace std;<br />
 const int maxn=+,maxm=+;<br />
 int x[maxm],y[maxm],w[maxm],sig[maxm],ance[maxn],ans[maxn];<br />
 int n,m,k,tot,cnt,captedge;<br />
 double l,r,mid;<br />
 bool cmp(int a,int b)<br />
 {<br />
  return (w[a]+(x[a]==)*mid)&lt;(w[b]+(x[b]==)*mid);//这个算法的核心<br />
 }<br />
 int findance(int x)<br />
 {<br />
  if(x==ance[x])return x;<br />
      else return ance[x]=findance(ance[x]);<br />
 }<br />
 void Kruskal(bool flag)<br />
 {<br />
  cnt=captedge=;<br />
  for(int i=;i&lt;=n;i++)<br />
      {<br />
       ance[i]=i;<br />
     }<br />
  sort(sig,sig+m,cmp);<br />
  for(int i=;i&lt;m;i++)<br />
      {<br />
       if(cnt+==n)    return ;<br />
       int j=sig[i];<br />
       int u=findance(x[j]),v=findance(y[j]);<br />
       if((u!=v)&amp;&amp;(flag||(captedge+(x[j]==))&lt;=k))

         {<br />
          ance[u]=v;<br />
          ans[cnt++]=j;<br />
          if(x[j]==)captedge++;<br />
         }<br />
     }<br />
 }<br />
 int main()<br />
 {<br />
  ios::sync_with_stdio(false);<br />
  freopen("t.txt","r",stdin);<br />
  cin&gt;&gt;n&gt;&gt;m&gt;&gt;k;<br />
  tot=;<br />
  for(int i=;i&lt;m;i++)<br />
      {<br />
       sig[i]=i;<br />
      cin&gt;&gt;x[i]&gt;&gt;y[i]&gt;&gt;w[i];<br />
      if(x[i]&gt;y[i]){int t=x[i];x[i]=y[i];y[i]=t;}//swap<br />
      if(x[i]==)tot++;<br />
     }<br />
  if((k&gt;tot)||(k==&amp;&amp;n&gt;))<br />
      {<br />
       cout&lt;&lt;"-1"&lt;&lt;endl;<br />
      return ;<br />
     }<br />
  cnt=;<br />
  Kruskal();<br />
  if(cnt!=(n-))<br />
      {<br />
       cout&lt;&lt;"-1"&lt;&lt;endl;<br />
      return ;<br />
     }<br />
  l=(-)*100000.0;<br />
  r=100000.0;<br />
  while(((l+1e-)&lt;r)&amp;&amp;(captedge!=k))<br />
      {<br />
       mid=(l+r)/2.0;<br />
       Kruskal();<br />
       if(captedge&lt;k)r=mid;<br />
           else l=mid;<br />
     }<br />
  if(captedge!=k)mid=(l+r)/2.0;<br />
  Kruskal();<br />
  cout&lt;&lt;n-&lt;&lt;endl;<br />
  if(cnt&gt;=)cout&lt;&lt;ans[]+;<br />
  for(int i=;i&lt;cnt;i++)<br />
      cout&lt;&lt;" "&lt;&lt;ans[i]+;<br />
  cout&lt;&lt;endl;<br />
  return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kngr8j.html">JAVA装饰者模式（从现实生活角度理解代码原理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2kzyoq.html">在iOS APP中使用H5显示百度地图时如何支持HTTPS？</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwd4dq.html">Loader加载器</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mvwno8.html">如何在网页端启动WinForm 程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mne122q.html">DuiLib&mdash;&mdash;第二篇UIBase</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yze00q.html">rman的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdvnlk8.html">&lbrack;CSS&rsqb;图片与文字对齐问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1yzyd9.html">http&colon;&sol;&sol;www&period;cnblogs&period;com&sol;chillsrc&sol;category&sol;49632&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm57gx9.html">坑到了，EF执行带事物的存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vl00o8.html">&lbrack;置顶&rsqb; mysql中的set和enum类型的用法和区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v0lzj8.html">Java文件操作二：File文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn7j0oq.html">android-wear开发之定义布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ze7me9.html">Codeforces Round &num;386 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gernj78.html">CNN网络介绍与实践：王者荣耀英雄图片识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdy719.html">ML笔记：Classification&colon; Logistic Regression</a>
		</li>
						<li><a href="https://www.batexi.com/a/96003mn9.html">roadhog如何支持除development和production外的其他环境变量配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwzxyj9.html">网卡最大传输单位MTU和巨型帧&lpar;Jumbo frame&rpar;设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dy4w9.html">学习DDD之路--勇于纠正自己的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47xnm9.html">2017-2018-2 20155303『网络对抗技术』Exp4：恶意代码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vpzx4q.html">PAT Waiting in Line&lbrack;转载&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jznz0w8.html">php script 的生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpdpyxq.html">at 定时任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljnlme9.html">CSS中的浮动清除</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14yvgq.html">Varnish Cache</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melddoq.html">从零开始HTML</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy142zmq.html">&lbrack;SQLite&rsqb;SQL语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/950mm4m8.html">Mac上ssh无法登录的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy0v48.html">onchange、oninput、onpropertyChange事件的异同</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2wlj8.html">蓝牙协议 基于TI cc2540 模块的理解（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zorekvq.html">聊聊Node&period;js 独立日漏洞</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
